local hackedCars = {}

local enabledAll = false

function init()
    RegisterTool("vhack", "Hack vehicle", "")
	SetBool("game.tool.vhack.enabled", true)
end

function tick(dt)
    SetInt("game.tool.vhack.ammo", GetInt("game.tool.gun.ammo"))

    if GetString("game.player.tool") == "vhack" then
        local camTransform = GetCameraTransform()
        QueryRequire("dynamic")
        local dir = TransformToParentVec(camTransform, Vec(0, 0, -1))
        local hit, d, n, s = QueryRaycast(camTransform.pos, dir, 100)    

        if InputPressed("R") then
            if enabledAll then
                hackedCars = {}
                enabledAll = false
            else
                enabledAll = true
                local list = QueryAabbBodies(Vec(-1024, -1024, -1024), Vec(1024, 1024, 1024))
                for i=1, #list do
                    local body = list[i]
                    local vehicle = GetBodyVehicle(body)
                    if vehicle ~= 0 then
                        table.insert(hackedCars, {v = vehicle, stucktime = 0.0, isBack = false, rnd = math.random(-1.0, 1.0), isStopped = false})
                    end
                end
            end
        end

        if hit then
            local hitPoint = VecAdd(camTransform.pos, VecScale(dir, d))
            local body = GetShapeBody(s)
            local vehicle = GetBodyVehicle(body)
            if vehicle ~= 0 then
                DrawBodyOutline(body,1,1,1,0.5)
            end
            if InputPressed("usetool") then
                if vehicle ~= 0 then
                    local isRemoving = false
                    for i=1,#hackedCars do
                        if hackedCars[i].v == vehicle then
                            changeLight(vehicle, false)
                            table.remove(hackedCars, i)
                            isRemoving = true
                            return
                        end
                    end
                    if isRemoving == false then
                        changeLight(vehicle, true)
                        table.insert(hackedCars, {v = vehicle, stucktime = 0.0, isBack = false, rnd = math.random(-1.0, 1.0), isStopped = false})
                    end
                end
            end
        end
    end

    for i=1,#hackedCars do
        updateAI(i, dt)
    end
end

function draw()
    if GetString("game.player.tool") == "vhack" then
        UiAlign("center")
        UiTranslate(UiCenter(),UiHeight()-60)
        UiFont("regular.ttf", 24)
        UiText("LMB to hack car or R to hack all cars")
    end
end

function changeLight(vehicle, t)
    local shapes = GetBodyShapes(GetVehicleBody(vehicle))
    for i=1, #shapes do
        local lights = GetShapeLights(shapes[i])
        for j=1, #lights do
            if t then
             SetLightColor(lights[j], 1, 0, 0)
            else
             SetLightColor(lights[j], 1, 1, 1)
            end
        end
    end
end

function updateAI(i, dt)
    if hackedCars[i].v == nil or i > #hackedCars then
        return
    end
    local vehicle = hackedCars[i].v
    local t = GetVehicleTransform(vehicle)
    local vehicleToWaypoint = VecSub(t.pos,GetPlayerPos())

    local forward = TransformToParentVec(t, Vec(0,0,1))
    local steerCross = VecCross(VecNormalize(vehicleToWaypoint), forward);
    local steerDirection = VecDot(VecNormalize(steerCross), Vec(0,1,0));
    local steer = VecLength(steerCross) * steerDirection;
    local lights = GetShapeLights(shape)
    

    local speed = 1

    QueryRejectVehicle(vehicle)
    QueryRequire("static large")
    local tr = Transform(VecAdd(t.pos,Vec(0,1,0)),t.rot)
    
    local leftTest = TransformToParentVec(tr, Vec(0.5,0,-1))
    local hit, d = QueryRaycast(tr.pos, leftTest, 6)

    if hit then
        steer = -1
        speed = 0.4
    end
    QueryRejectVehicle(vehicle)
    QueryRequire("static large")
    local rightTest = TransformToParentVec(tr, Vec(-0.5,0,-1))
    local hit, d = QueryRaycast(tr.pos, rightTest, 6)

    if hit then
        steer = 1
        speed = 0.4
    end

    QueryRejectVehicle(vehicle)
    QueryRequire("static large")
    local stopTest = TransformToParentVec(tr, Vec(0,0,-1))
    local hit, d = QueryRaycast(tr.pos, stopTest, 3)

    local velstop = GetBodyVelocity(GetVehicleBody(vehicle))

    if hit then
        speed = 0.0
        if hackedCars[i].isBack == false then
           -- SetBodyVelocity(GetVehicleBody(vehicle), VecScale(velstop,0.98))
        end
    end
    
    if hackedCars[i].isBack == false then
        if VecLength(GetBodyVelocity(GetVehicleBody(vehicle))) < 0.5 then
            hackedCars[i].stucktime = hackedCars[i].stucktime + dt
        else
            hackedCars[i].stucktime = 0.0
        end
        if hackedCars[i].stucktime > 1.0 then
            hackedCars[i].stucktime = 2.0
            hackedCars[i].isBack = true
            hackedCars[i].isStopped = false
        end
    else
        hackedCars[i].stucktime = hackedCars[i].stucktime - dt
        if hackedCars[i].stucktime <= 0.0 then
            hackedCars[i].isBack = false
            hackedCars[i].stucktime = 0.0
        end
    end

    hackedCars[i].rnd = hackedCars[i].rnd + dt*2

   --crazyJoints(GetVehicleBody(vehicle), math.abs(math.sin(hackedCars[i].rnd)))
    if hackedCars[i].isStopped == false then
        if hackedCars[i].isBack == false then
            DriveVehicle(vehicle, speed, -steer, false)
        else
            DriveVehicle(vehicle, -1, steer, false)
        end
    end

    QueryRejectVehicle(vehicle)
    local forwardTest = TransformToParentVec(tr, Vec(0,-0.2,-1))
    local hit, d = QueryRaycast(tr.pos, forwardTest, 16)

    if hit == false then
        if hackedCars[i].isBack == false then
            hackedCars[i].isStopped = true
          --  SetBodyVelocity(GetVehicleBody(vehicle), VecScale(velstop,0.7))
        end
    end

    local health = GetVehicleHealth(vehicle)
    if health < 0.01 then
        table.remove(hackedCars,i)
    end
end

function crazyJoints(body, value) -- doesn't work
    local shapes = GetBodyShapes(body)
    for i=1, #shapes do
        local hinges = GetShapeJoints(shapes[i])
        for j=1, #hinges do
            local hinge = hinges[j]
            if value > 0.5 then
                SetJointMotorTarget(hinge, -40, 0.5)
            else
                SetJointMotorTarget(hinge, 0, 0.5)
            end
            DebugPrint(value)
        end
    end
end

function dist(a, b)
	return VecLength(VecSub(a,b))
end

function clamp(n, low, high)
    return math.min(math.max(n, low), high)
end